com.fasterxml.jackson.databind

## Class JsonDeserializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>

All Implemented Interfaces:
  NullValueProvider

Direct Known Subclasses:
  AbstractDeserializer, ErrorThrowingDeserializer, JsonDeserializer.None, StdDeserializer, TypeWrappedDeserializer

    public abstract class JsonDeserializer<T>
    extends Object
    implements NullValueProvider

Abstract class that defines API used by `ObjectMapper` (and other chained `JsonDeserializer`s too) to deserialize Objects of arbitrary types from JSON, using provided `JsonParser`.

Custom deserializers should usually not directly extend this class, but instead extend `StdDeserializer` (or its subtypes like `StdScalarDeserializer`).

If deserializer is an aggregate one -- meaning it delegates handling of some of its contents by using other deserializer(s) -- it typically also needs to implement `ResolvableDeserializer`, which can locate dependant deserializers. This is important to allow dynamic overrides of deserializers; separate call interface is needed to separate resolution of dependant deserializers (which may have cyclic link back to deserializer itself, directly or indirectly).

In addition, to support per-property annotations (to configure aspects of deserialization on per-property basis), deserializers may want to implement `ContextualDeserializer`, which allows specialization of deserializers: call to `ContextualDeserializer.createContextual(com.fasterxml.jackson.databind.DeserializationContext, com.fasterxml.jackson.databind.BeanProperty)` is passed information on property, and can create a newly configured deserializer for handling that particular property.

If both `ResolvableDeserializer` and `ContextualDeserializer` are implemented, resolution of deserializers occurs before contextualization.

### Nested Class Summary

Nested Classes
`static class` `JsonDeserializer.None` This marker class is only to be used with annotations, to indicate that no deserializer is configured.

### Constructor Summary

Constructors
Constructor and Description
`JsonDeserializer()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
`abstract T` `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`T` `deserialize(JsonParser p, DeserializationContext ctxt, T intoValue)` Alternate deserialization method (compared to the most commonly used, `deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
`Object` `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype.
`Object` `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer, T intoValue)` Method similar to `deserializeWithType(JsonParser,DeserializationContext,TypeDeserializer)` but called when merging value.
`SettableBeanProperty` `findBackReference(String refName)` Method needed by `BeanDeserializerFactory` to properly link managed- and back-reference pairs.
`Object` `getAbsentValue(DeserializationContext ctxt)` Method called to determine placeholder value to be used for cases where no value was obtained from input but we must pass a value nonetheless: the common case is that of Creator methods requiring passing a value for every parameter.
`JsonDeserializer<?>` `getDelegatee()` Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls.
`AccessPattern` `getEmptyAccessPattern()` This method may be called in conjunction with calls to `getEmptyValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.
`Object` `getEmptyValue()` Deprecated. Since 2.6 Use overloaded variant that takes context argument
`Object` `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
`Collection<Object>` `getKnownPropertyNames()` Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name.
`AccessPattern` `getNullAccessPattern()` This method may be called in conjunction with calls to `getNullValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.
`T` `getNullValue()` Deprecated. Since 2.6 Use overloaded variant that takes context argument
`T` `getNullValue(DeserializationContext ctxt)` Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`).
`ObjectIdReader` `getObjectIdReader()` Accessor that can be used to check whether this deserializer is expecting to possibly get an Object Identifier value instead of full value serialization, and if so, should be able to resolve it to actual Object instance to return as deserialized value.
`Class<?>` `handledType()` Method for accessing concrete physical type of values this deserializer produces.
`boolean` `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
`LogicalType` `logicalType()` Method for accessing logical type of values this deserializer produces.
`JsonDeserializer<?>` `replaceDelegatee(JsonDeserializer<?> delegatee)` Method that can be called to try to replace deserializer this deserializer delegates calls to.
`Boolean` `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.
`JsonDeserializer<T>` `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### JsonDeserializer

    public JsonDeserializer()

### Method Detail

#### deserialize

    public abstract T deserialize(JsonParser p,
                                  DeserializationContext ctxt)
                           throws IOException,
                                  JacksonException

Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (p.currentToken() == JsonToken.START_OBJECT) {
             p.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`
  `JacksonException`

#### deserialize

    public T deserialize(JsonParser p,
                         DeserializationContext ctxt,
                         T intoValue)
                  throws IOException,
                         JacksonException

Alternate deserialization method (compared to the most commonly used, `deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

Throws:
  `IOException`
  `JacksonException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser p,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException,
                                      JacksonException

Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype. This can be due to annotation on type (or its supertype), or due to global settings without annotations.

Default implementation may work for some types, but ideally subclasses should not rely on current default implementation. Implementation is mostly provided to avoid compilation errors with older code.

Parameters:
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`
  `JacksonException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser p,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer,
                                      T intoValue)
                               throws IOException,
                                      JacksonException

Method similar to `deserializeWithType(JsonParser,DeserializationContext,TypeDeserializer)` but called when merging value. Considered "bad merge" by default implementation, but if `MapperFeature.IGNORE_MERGE_FOR_UNMERGEABLE` is enabled will simple delegate to `deserializeWithType(JsonParser, DeserializationContext, TypeDeserializer)`.

Throws:
  `IOException`
  `JacksonException`
Since:
  2.10

#### unwrappingDeserializer

    public JsonDeserializer<T> unwrappingDeserializer(NameTransformer unwrapper)

Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

Default implementation just returns 'this' indicating that no unwrapped variant exists

#### replaceDelegatee

    public JsonDeserializer<?> replaceDelegatee(JsonDeserializer<?> delegatee)

Method that can be called to try to replace deserializer this deserializer delegates calls to. If not supported (either this deserializer does not delegate anything; or it does not want any changes), should either throw `UnsupportedOperationException` (if operation does not make sense or is not allowed); or return this deserializer as is.

Since:
  2.1

#### handledType

    public Class<?> handledType()

Method for accessing concrete physical type of values this deserializer produces. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

Default implementation will return null, which means almost same same as returning `Object.class` would; that is, that nothing is known about handled type.

Returns:
  Physical type of values this deserializer produces, if known; `null` if not
Since:
  2.3

#### logicalType

    public LogicalType logicalType()

Method for accessing logical type of values this deserializer produces. Typically used for further configuring handling of values, for example, to find which coercions are legal.

Returns:
  Logical type of values this deserializer produces, if known; `null` if not
Since:
  2.12

#### isCachable

    public boolean isCachable()

Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

Default implementation returns false, to indicate that no caching is done.

#### getDelegatee

    public JsonDeserializer<?> getDelegatee()

Accessor that can be used to determine if this deserializer uses another deserializer for actual deserialization, by delegating calls. If so, will return immediate delegate (which itself may delegate to further deserializers); otherwise will return null.

Returns:
  Deserializer this deserializer delegates calls to, if null; null otherwise.
Since:
  2.1

#### getKnownPropertyNames

    public Collection<Object> getKnownPropertyNames()

Method that will either return null to indicate that type being deserializers has no concept of properties; or a collection of identifiers for which `toString` will give external property name. This is only to be used for error reporting and diagnostics purposes (most commonly, to accompany "unknown property" exception).

Since:
  2.0

#### getNullValue

    public T getNullValue(DeserializationContext ctxt)
                   throws JsonMappingException

Method that can be called to determine value to be used for representing null values (values deserialized when JSON token is `JsonToken.VALUE_NULL`). Usually this is simply Java null, but for some types (especially primitives) it may be necessary to use non-null values.

This method may be called once, or multiple times, depending on what `getNullAccessPattern()` returns.

Default implementation simply returns null.

Specified by:
  `getNullValue` in interface `NullValueProvider`
Throws:
  `JsonMappingException`
Since:
  2.6 Added to replace earlier no-arguments variant

#### getNullAccessPattern

    public AccessPattern getNullAccessPattern()

This method may be called in conjunction with calls to `getNullValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.

Default implementation indicates that the "null value" to use for input null does not vary across uses so that `getNullValue(DeserializationContext)` need not be called more than once per deserializer instance. This information may be used as optimization.

Specified by:
  `getNullAccessPattern` in interface `NullValueProvider`

#### getAbsentValue

    public Object getAbsentValue(DeserializationContext ctxt)
                          throws JsonMappingException

Method called to determine placeholder value to be used for cases where no value was obtained from input but we must pass a value nonetheless: the common case is that of Creator methods requiring passing a value for every parameter. Usually this is same as `getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java `null`), but it can be overridden for specific types: most notable scalar types must use "default" values.

This method needs to be called every time a determination is made.

Default implementation simply calls `getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Specified by:
  `getAbsentValue` in interface `NullValueProvider`
Throws:
  `JsonMappingException`
Since:
  2.13

#### getEmptyValue

    public Object getEmptyValue(DeserializationContext ctxt)
                         throws JsonMappingException

Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for specific types. Or, if type should never be converted from empty String, method can also throw an exception.

This method may be called once, or multiple times, depending on what `getEmptyAccessPattern()` returns.

Default implementation simply calls `getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Throws:
  `JsonMappingException`
Since:
  2.6 Added to replace earlier no-arguments variant

#### getEmptyAccessPattern

    public AccessPattern getEmptyAccessPattern()

This method may be called in conjunction with calls to `getEmptyValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.

Since:
  2.9

#### getObjectIdReader

    public ObjectIdReader getObjectIdReader()

Accessor that can be used to check whether this deserializer is expecting to possibly get an Object Identifier value instead of full value serialization, and if so, should be able to resolve it to actual Object instance to return as deserialized value.

Default implementation returns null, as support cannot be implemented generically. Some standard deserializers (most notably `BeanDeserializer`) do implement this feature, and may return reader instance, depending on exact configuration of instance (which is based on type, and referring property).

Returns:
  ObjectIdReader used for resolving possible Object Identifier value, instead of full value serialization, if deserializer can do that; null if no Object Id is expected.
Since:
  2.0

#### findBackReference

    public SettableBeanProperty findBackReference(String refName)

Method needed by `BeanDeserializerFactory` to properly link managed- and back-reference pairs.

Since:
  2.2 (was moved out of `BeanDeserializerBase`)

#### supportsUpdate

    public Boolean supportsUpdate(DeserializationConfig config)

Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserializer construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

Default implementation returns `null` to allow explicit per-type or per-property attempts.

Since:
  2.9

#### getNullValue

    @Deprecated
    public T getNullValue()

Deprecated. Since 2.6 Use overloaded variant that takes context argument

#### getEmptyValue

    @Deprecated
    public Object getEmptyValue()

Deprecated. Since 2.6 Use overloaded variant that takes context argument